
package com.google.api.ads.adwords.jaxws.v201206.cm;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * 
 *       Use this service to manage criteria (such as {@linkplain Keyword keywords} or
 *       {@linkplain Placement placements}). A criterion describes the conditions that
 *       determine if an ad should display. Two classes of criteria are available:
 *       <ul>
 *       <li>A {@linkplain BiddableAdGroupCriterion biddable criterion} defines
 *       conditions that will cause the parent ad group's ads to display. A biddable
 *       criterion can also specify a bid amount that overrides the parent ad group's
 *       default bid.</li>
 *       <li>A {@linkplain NegativeAdGroupCriterion negative criterion} defines
 *       conditions that will prevent the parent ad group's ads from displaying.</li>
 *       </ul>
 *     
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.4-b01
 * Generated source version: 2.2
 * 
 */
@WebService(name = "AdGroupCriterionServiceInterface", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
@XmlSeeAlso({
    ObjectFactory.class
})
public interface AdGroupCriterionServiceInterface {


    /**
     * 
     *         Gets adgroup criteria.
     *         
     *         @param serviceSelector filters the adgroup criteria to be returned.
     *         @return a page (subset) view of the criteria selected
     *         @throws ApiException when there is at least one error with the request
     *       
     * 
     * @param serviceSelector
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionPage
     * @throws ApiException_Exception
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
    @RequestWrapper(localName = "get", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfaceget")
    @ResponseWrapper(localName = "getResponse", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfacegetResponse")
    public AdGroupCriterionPage get(
        @WebParam(name = "serviceSelector", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
        Selector serviceSelector)
        throws ApiException_Exception
    ;

    /**
     * 
     *         Adds, removes or updates adgroup criteria.
     *         
     *         @param operations operations to do
     *         during checks on keywords to be added.
     *         @return added and updated adgroup criteria (without optional parts)
     *         @throws ApiException when there is at least one error with the request
     *       
     * 
     * @param operations
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionReturnValue
     * @throws ApiException_Exception
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
    @RequestWrapper(localName = "mutate", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfacemutate")
    @ResponseWrapper(localName = "mutateResponse", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfacemutateResponse")
    public AdGroupCriterionReturnValue mutate(
        @WebParam(name = "operations", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
        List<AdGroupCriterionOperation> operations)
        throws ApiException_Exception
    ;

    /**
     * 
     *         Returns the list of AdGroupCriterion that match the query.
     *         
     *         @param query The SQL-like AWQL query string
     *         @returns A list of AdGroupCriterion
     *         @throws ApiException when the query is invalid or there are errors processing the request.
     *       
     * 
     * @param query
     * @return
     *     returns com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionPage
     * @throws ApiException_Exception
     */
    @WebMethod
    @WebResult(name = "rval", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
    @RequestWrapper(localName = "query", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfacequery")
    @ResponseWrapper(localName = "queryResponse", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206", className = "com.google.api.ads.adwords.jaxws.v201206.cm.AdGroupCriterionServiceInterfacequeryResponse")
    public AdGroupCriterionPage query(
        @WebParam(name = "query", targetNamespace = "https://adwords.google.com/api/adwords/cm/v201206")
        String query)
        throws ApiException_Exception
    ;

}
